Index: trunk/source/Lib/TLibCommon/TComUpsampleFilter.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComUpsampleFilter.cpp	(revision 230)
+++ trunk/source/Lib/TLibCommon/TComUpsampleFilter.cpp	(revision 310)
@@ -248,514 +173,344 @@
   else
   {
-#if PHASE_DERIVATION_IN_INTEGER
-  Int refPos16 = 0;
-  Int phase    = 0;
-  Int refPos   = 0; 
-  Int* coeff = m_chromaFilter[phase];
-  for ( i = 0; i < 16; i++)
-  {
-    memcpy(   m_lumaFilter[i],   m_lumaFixedFilter[i], sizeof(Int) * NTAPS_US_LUMA   );
-    memcpy( m_chromaFilter[i], m_chromaFixedFilter[i], sizeof(Int) * NTAPS_US_CHROMA );
-  }
-#else
-  for ( i = 0; i < 12; i++)
-  {
-    memcpy( m_lumaFilter[i], m_lumaFixedFilter[i], sizeof(Int) * NTAPS_US_LUMA );
-  }
-
-  Int chromaPhaseDenominator;
-  if (widthEL == 2*widthBL) // 2x scalability
-  {
-    for ( i = 0; i < 8; i++)
-    {
-      memcpy( m_chromaFilter[i], m_chromaFixedFilter20[i], sizeof(Int) * NTAPS_US_CHROMA );
-    }
-    chromaPhaseDenominator = 8;
-  }
-  else
-  {
-    for ( i = 0; i < 12; i++) // 1.5x scalability
-    {
-      memcpy( m_chromaFilter[i], m_chromaFixedFilter15[i], sizeof(Int) * NTAPS_US_CHROMA );
-    }
-    chromaPhaseDenominator = 12;
-  }
-#endif
-
-  assert ( widthEL == widthBL || widthEL == 2*widthBL || 2*widthEL == 3*widthBL );
-  assert ( heightEL == heightBL || heightEL == 2*heightBL || 2*heightEL == 3*heightBL );
-
-#if JCTVC_L0178
-  // save the cropped region to copy back to the base picture since the base picture might be used as a reference picture
-  if( tempBufSizeRight )
-  {
-    piSrcY = piSrcBufY + widthBL;
-    piDstY = tempBufRight;
-    for( i = 0; i < pcBasePic->getHeight(); i++ )
-    {
-      memcpy(piDstY, piSrcY, sizeof(Pel) * confBL.getWindowRightOffset());
-      piSrcY += strideBL;
-      piDstY += confBL.getWindowRightOffset();
-    }
-    
-    if(confBL.getWindowRightOffset()>>1)
-    {
-      Int strideBLChroma = (strideBL>>1);
-      piSrcU = piSrcBufU + (widthBL>>1);
-      piDstU = tempBufRight + confBL.getWindowRightOffset() * pcBasePic->getHeight();
-      piSrcV = piSrcBufV + (widthBL>>1);
-      piDstV = piDstU + (confBL.getWindowRightOffset()>>1) * (pcBasePic->getHeight()>>1);
-    
-      for( i = 0; i < pcBasePic->getHeight()>>1; i++ )
-      {
-        memcpy(piDstU, piSrcU, sizeof(Pel) * (confBL.getWindowRightOffset()>>1));
-        piSrcU += strideBLChroma;
-        piDstU += (confBL.getWindowRightOffset()>>1);
-        
-        memcpy(piDstV, piSrcV, sizeof(Pel) * (confBL.getWindowRightOffset()>>1));
-        piSrcV += strideBLChroma;
-        piDstV += (confBL.getWindowRightOffset()>>1);
-      }
-    }
-    
-    pcBasePic->setWidth(widthBL);
-  }
-  
-  if( tempBufSizeBottom )
-  {
-    piSrcY = piSrcBufY + heightBL * strideBL;
-    piDstY = tempBufBottom;
-    for( i = 0; i < confBL.getWindowBottomOffset(); i++ )
-    {
-      memcpy(piDstY, piSrcY, sizeof(Pel) * pcBasePic->getWidth());
-      piSrcY += strideBL;
-      piDstY += pcBasePic->getWidth();
-    }
-    
-    if(confBL.getWindowBottomOffset()>>1)
-    {
-      Int strideBLChroma = (strideBL>>1);
-      piSrcU = piSrcBufU + (heightBL>>1) * strideBLChroma;
-      piDstU = tempBufBottom + confBL.getWindowBottomOffset() * pcBasePic->getWidth();
-      piSrcV = piSrcBufV + (heightBL>>1) * strideBLChroma;
-      piDstV = piDstU + (confBL.getWindowBottomOffset()>>1) * (pcBasePic->getWidth()>>1);
+    Int refPos16 = 0;
+    Int phase    = 0;
+    Int refPos   = 0; 
+    Int* coeff = m_chromaFilter[phase];
+    for ( i = 0; i < 16; i++)
+    {
+      memcpy(   m_lumaFilter[i],   m_lumaFixedFilter[i], sizeof(Int) * NTAPS_US_LUMA   );
+      memcpy( m_chromaFilter[i], m_chromaFixedFilter[i], sizeof(Int) * NTAPS_US_CHROMA );
+    }
+
+    assert ( widthEL == widthBL || widthEL == 2*widthBL || 2*widthEL == 3*widthBL );
+    assert ( heightEL == heightBL || heightEL == 2*heightBL || 2*heightEL == 3*heightBL );
+
+    pcBasePic->setBorderExtension(false);
+    pcBasePic->extendPicBorder   (); // extend the border.
+
+    Int   shiftX = 16;
+    Int   shiftY = 16;
+
+    Int   phaseX = 0;
+    Int   phaseY = 0;
+
+    Int   addX       = ( ( ( widthBL * phaseX ) << ( shiftX - 2 ) ) + ( widthEL >> 1 ) ) / widthEL + ( 1 << ( shiftX - 5 ) );
+    Int   addY       = ( ( ( heightBL * phaseY ) << ( shiftY - 2 ) ) + ( heightEL >> 1 ) ) / heightEL+ ( 1 << ( shiftY - 5 ) );
+
+    Int   deltaX     = 4 * phaseX;
+    Int   deltaY     = 4 * phaseY;  
+
+    Int shiftXM4 = shiftX - 4;
+    Int shiftYM4 = shiftY - 4;
+
+#if ILP_DECODED_PICTURE
+    widthEL   = pcUsPic->getWidth ();
+    heightEL  = pcUsPic->getHeight();
+
+    widthBL   = pcBasePic->getWidth ();
+    heightBL  = min<Int>( pcBasePic->getHeight(), heightEL );
+#endif
+#if SCALED_REF_LAYER_OFFSETS
+    Int leftStartL = scalEL.getWindowLeftOffset();
+    Int rightEndL  = pcUsPic->getWidth() - scalEL.getWindowRightOffset();
+    Int topStartL  = scalEL.getWindowTopOffset();
+    Int bottomEndL = pcUsPic->getHeight() - scalEL.getWindowBottomOffset();
+#endif
+
+    //========== horizontal upsampling ===========
+    for( i = 0; i < widthEL; i++ )
+    {
+#if SCALED_REF_LAYER_OFFSETS
+      Int x = Clip3( leftStartL, rightEndL - 1, i );
+      refPos16 = (((x - leftStartL)*scaleX + addX) >> shiftXM4) - deltaX;
+#else
+      refPos16 = ((i*scaleX + addX) >> shiftXM4) - deltaX;
+#endif
+      phase    = refPos16 & 15;
+      refPos   = refPos16 >> 4;
+      coeff = m_lumaFilter[phase];
+
+      piSrcY = piSrcBufY + refPos -((NTAPS_US_LUMA>>1) - 1);
+      piDstY = piTempBufY + i;
+
+      for( j = 0; j < heightBL ; j++ )
+      {
+        *piDstY = sumLumaHor(piSrcY, coeff);
+        piSrcY += strideBL;
+        piDstY += strideEL;
+      }
+    }
+
+    //========== vertical upsampling ===========
+    pcTempPic->setBorderExtension(false);
+    pcTempPic->setHeight(heightBL);
+    pcTempPic->extendPicBorder   (); // extend the border.
+    pcTempPic->setHeight(heightEL);
+
+    const Int nShift = US_FILTER_PREC*2;
+    Int iOffset = 1 << (nShift - 1); 
+
+#if SCALED_REF_LAYER_OFFSETS
+    for( j = 0; j < pcTempPic->getHeight(); j++ )
+#else
+    for( j = 0; j < heightEL; j++ )
+#endif
+    {
+#if SCALED_REF_LAYER_OFFSETS
+      Int y = Clip3(topStartL, bottomEndL - 1, j);
+      refPos16 = ((( y - topStartL )*scaleY + addY) >> shiftYM4) - deltaY;
+#else
+      refPos16 = ((j*scaleY + addY) >> shiftYM4) - deltaY;
+#endif
+      phase    = refPos16 & 15;
+      refPos   = refPos16 >> 4;
+      coeff = m_lumaFilter[phase];
+
+      piSrcY = piTempBufY + (refPos -((NTAPS_US_LUMA>>1) - 1))*strideEL;
+#if SCALED_REF_LAYER_OFFSETS
+#if 1 // it should provide identical result
+      Pel* piDstY0 = piDstBufY + j * strideEL;            
+      piDstY = piDstY0 + ( leftStartL > 0 ? leftStartL : 0 );
+
+      for( i = min<Int>(rightEndL, pcTempPic->getWidth()) - max<Int>(0, leftStartL); i > 0; i-- )
+      {
+        *piDstY = ClipY( (sumLumaVer(piSrcY, coeff, strideEL) + iOffset) >> (nShift));
+        piSrcY++;
+        piDstY++;
+      }
+
+      for( i = rightEndL; i < pcTempPic->getWidth(); i++ )
+      {
+        *piDstY = piDstY0[rightEndL-1];
+        piDstY++;
+      }
+
+      piDstY = piDstY0;
+      for( i = 0; i < leftStartL; i++ )
+      {
+        *piDstY = piDstY0[leftStartL];
+        piDstY++;
+      }
+#else
+      piDstY = piDstBufY + j * strideEL;
+
+      for( i = 0; i < pcTempPic->getWidth(); i++ )
+      {
+        *piDstY = ClipY( (sumLumaVer(piSrcY, coeff, strideEL) + iOffset) >> (nShift));
+
+        // Only increase the x position of reference upsample picture when within the window
+        // "-2" to ensure that pointer doesn't go beyond the boundary rightEndL-1
+        if( (i >= leftStartL) && (i <= rightEndL-2) )
+        {
+          piSrcY++;
+        }
+        piDstY++;
+      }
+#endif
+#else
+      piDstY = piDstBufY + j * strideEL;
+
+      for( i = 0; i < widthEL; i++ )
+      {
+        *piDstY = ClipY( (sumLumaVer(piSrcY, coeff, strideEL) + iOffset) >> (nShift));
+        piSrcY++;
+        piDstY++;
+      }
+#endif
+    }
+
+#if ILP_DECODED_PICTURE
+#if SCALED_REF_LAYER_OFFSETS
+    widthBL   = pcBasePic->getWidth ();
+    heightBL  = pcBasePic->getHeight();
+
+    widthEL   = pcUsPic->getWidth () - scalEL.getWindowLeftOffset() - scalEL.getWindowRightOffset();
+    heightEL  = pcUsPic->getHeight() - scalEL.getWindowTopOffset()  - scalEL.getWindowBottomOffset();
+#else
+    widthBL   = pcBasePic->getWidth () - confBL.getWindowLeftOffset() - confBL.getWindowRightOffset();
+    heightBL  = pcBasePic->getHeight() - confBL.getWindowTopOffset() - confBL.getWindowBottomOffset();
+
+    widthEL   = pcUsPic->getWidth () - confEL.getWindowLeftOffset() - confEL.getWindowRightOffset();
+    heightEL  = pcUsPic->getHeight() - confEL.getWindowTopOffset() - confEL.getWindowBottomOffset();
+#endif
+#endif
+
+    //========== UV component upsampling ===========
+
+    widthEL  >>= 1;
+    heightEL >>= 1;
+
+    widthBL  >>= 1;
+    heightBL >>= 1;
+
+    strideBL  = pcBasePic->getCStride();
+    strideEL  = pcUsPic->getCStride();
+#if SCALED_REF_LAYER_OFFSETS
+    Int leftStartC = scalEL.getWindowLeftOffset() >> 1;
+    Int rightEndC  = (pcUsPic->getWidth() >> 1) - (scalEL.getWindowRightOffset() >> 1);
+    Int topStartC  = scalEL.getWindowTopOffset() >> 1;
+    Int bottomEndC = (pcUsPic->getHeight() >> 1) - (scalEL.getWindowBottomOffset() >> 1);
+#endif
+
+    shiftX = 16;
+    shiftY = 16;
+
+    phaseX = 0;
+    phaseY = 1;
+
+    addX       = ( ( ( widthBL * phaseX ) << ( shiftX - 2 ) ) + ( widthEL >> 1 ) ) / widthEL + ( 1 << ( shiftX - 5 ) );
+    addY       = ( ( ( heightBL * phaseY ) << ( shiftY - 2 ) ) + ( heightEL >> 1 ) ) / heightEL+ ( 1 << ( shiftY - 5 ) );
+
+    deltaX     = 4 * phaseX;
+    deltaY     = 4 * phaseY;
+
+    shiftXM4 = shiftX - 4;
+    shiftYM4 = shiftY - 4;
+
+#if !SIMPLIFIED_MV_POS_SCALING
+    scaleX     = ( ( widthBL << shiftX ) + ( widthEL >> 1 ) ) / widthEL;
+    scaleY     = ( ( heightBL << shiftY ) + ( heightEL >> 1 ) ) / heightEL;
+#endif
+
+#if ILP_DECODED_PICTURE
+    widthEL   = pcUsPic->getWidth () >> 1;
+    heightEL  = pcUsPic->getHeight() >> 1;
+
+    widthBL   = pcBasePic->getWidth () >> 1;
+    heightBL  = min<Int>( pcBasePic->getHeight() >> 1, heightEL );
+#endif
+
+    //========== horizontal upsampling ===========
+    for( i = 0; i < widthEL; i++ )
+    {
+#if SCALED_REF_LAYER_OFFSETS
+      Int x = Clip3(leftStartC, rightEndC - 1, i);
+      refPos16 = (((x - leftStartC)*scaleX + addX) >> shiftXM4) - deltaX;
+#else
+      refPos16 = ((i*scaleX + addX) >> shiftXM4) - deltaX;
+#endif
+      phase    = refPos16 & 15;
+      refPos   = refPos16 >> 4;
+      coeff = m_chromaFilter[phase];
+
+      piSrcU = piSrcBufU + refPos -((NTAPS_US_CHROMA>>1) - 1);
+      piSrcV = piSrcBufV + refPos -((NTAPS_US_CHROMA>>1) - 1);
+      piDstU = piTempBufU + i;
+      piDstV = piTempBufV + i;
+
+      for( j = 0; j < heightBL ; j++ )
+      {
+        *piDstU = sumChromaHor(piSrcU, coeff);
+        *piDstV = sumChromaHor(piSrcV, coeff);
+
+        piSrcU += strideBL;
+        piSrcV += strideBL;
+        piDstU += strideEL;
+        piDstV += strideEL;
+      }
+    }
+
+    //========== vertical upsampling ===========
+    pcTempPic->setBorderExtension(false);
+    pcTempPic->setHeight(heightBL << 1);
+    pcTempPic->extendPicBorder   (); // extend the border.
+    pcTempPic->setHeight(heightEL << 1);
+
+#if SCALED_REF_LAYER_OFFSETS
+    for( j = 0; j < pcTempPic->getHeight() >> 1; j++ )
+#else
+    for( j = 0; j < heightEL; j++ )
+#endif
+    {
+#if SCALED_REF_LAYER_OFFSETS
+      Int y = Clip3(topStartC, bottomEndC - 1, j);
+      refPos16 = (((y - topStartC)*scaleY + addY) >> shiftYM4) - deltaY;
+#else
+      refPos16 = ((j*scaleY + addY) >> shiftYM4) - deltaY;
+#endif
+      phase    = refPos16 & 15;
+      refPos   = refPos16 >> 4; 
+      coeff = m_chromaFilter[phase];
       
-      for( i = 0; i < confBL.getWindowBottomOffset()>>1; i++ )
-      {
-        memcpy(piDstU, piSrcU, sizeof(Pel) * (pcBasePic->getWidth()>>1));
-        piSrcU += strideBLChroma;
-        piDstU += (pcBasePic->getWidth()>>1);
-        
-        memcpy(piDstV, piSrcV, sizeof(Pel) * (pcBasePic->getWidth()>>1));
-        piSrcV += strideBLChroma;
-        piDstV += (pcBasePic->getWidth()>>1);
-      }
-    }
-
-    pcBasePic->setHeight(heightBL);
-  }
-#endif
-  
-  pcBasePic->setBorderExtension(false);
-  pcBasePic->extendPicBorder   (); // extend the border.
-
-#if PHASE_DERIVATION_IN_INTEGER
-  Int   shiftX = 16;
-  Int   shiftY = 16;
-
-  Int   phaseX = 0;
-  Int   phaseY = 0;
-
-  Int   addX       = ( ( ( widthBL * phaseX ) << ( shiftX - 2 ) ) + ( widthEL >> 1 ) ) / widthEL + ( 1 << ( shiftX - 5 ) );
-  Int   addY       = ( ( ( heightBL * phaseY ) << ( shiftY - 2 ) ) + ( heightEL >> 1 ) ) / heightEL+ ( 1 << ( shiftY - 5 ) );
-
-  Int   deltaX     = 4 * phaseX;
-  Int   deltaY     = 4 * phaseY;  
-  
-  Int shiftXM4 = shiftX - 4;
-  Int shiftYM4 = shiftY - 4;
-
-  Int   scaleX     = ( ( widthBL << shiftX ) + ( widthEL >> 1 ) ) / widthEL;
-  Int   scaleY     = ( ( heightBL << shiftY ) + ( heightEL >> 1 ) ) / heightEL;
-#else
-  const Double sFactor = 1.0 * widthBL / widthEL;
-  const Double sFactor12 = sFactor * 12;
-#endif
-#if ILP_DECODED_PICTURE
-  widthEL   = pcUsPic->getWidth ();
-  heightEL  = pcUsPic->getHeight();
-
-  widthBL   = pcBasePic->getWidth ();
-  heightBL  = min<Int>( pcBasePic->getHeight(), heightEL );
-#endif
-#if SCALED_REF_LAYER_OFFSETS
-  Int leftStartL = scalEL.getWindowLeftOffset();
-  Int rightEndL  = pcUsPic->getWidth() - scalEL.getWindowRightOffset();
-  Int topStartL  = scalEL.getWindowTopOffset();
-  Int bottomEndL = pcUsPic->getHeight() - scalEL.getWindowBottomOffset();
-#endif
-
-  //========== horizontal upsampling ===========
-  for( i = 0; i < widthEL; i++ )
-  {
-#if SCALED_REF_LAYER_OFFSETS
-    Int x = Clip3( leftStartL, rightEndL - 1, i );
-#endif
-#if PHASE_DERIVATION_IN_INTEGER
-#if SCALED_REF_LAYER_OFFSETS
-    refPos16 = (((x - leftStartL)*scaleX + addX) >> shiftXM4) - deltaX;
-#else
-    refPos16 = ((i*scaleX + addX) >> shiftXM4) - deltaX;
-#endif
-    phase    = refPos16 & 15;
-    refPos   = refPos16 >> 4;
-    coeff = m_lumaFilter[phase];
-#else
-    Int refPos12 = (Int) ( i * sFactor12 );
-    Int refPos = (Int)( i * sFactor );
-    Int phase = (refPos12 + 12) % 12; 
-    Int* coeff = m_lumaFilter[phase];
-#endif
-
-    piSrcY = piSrcBufY + refPos -((NTAPS_US_LUMA>>1) - 1);
-    piDstY = piTempBufY + i;
-
-    for( j = 0; j < heightBL ; j++ )
-    {
-      *piDstY = sumLumaHor(piSrcY, coeff);
-      piSrcY += strideBL;
-      piDstY += strideEL;
-    }
-  }
-
-
-  //========== vertical upsampling ===========
-  pcTempPic->setBorderExtension(false);
-  pcTempPic->setHeight(heightBL);
-  pcTempPic->extendPicBorder   (); // extend the border.
-  pcTempPic->setHeight(heightEL);
-
-  const Int nShift = US_FILTER_PREC*2;
-  Int iOffset = 1 << (nShift - 1); 
-
-#if SCALED_REF_LAYER_OFFSETS
-  for( j = 0; j < pcTempPic->getHeight(); j++ )
-#else
-  for( j = 0; j < heightEL; j++ )
-#endif
-  {
-#if SCALED_REF_LAYER_OFFSETS
-    Int y = Clip3(topStartL, bottomEndL - 1, j);
-#endif
-#if PHASE_DERIVATION_IN_INTEGER
-#if SCALED_REF_LAYER_OFFSETS
-    refPos16 = ((( y - topStartL )*scaleY + addY) >> shiftYM4) - deltaY;
-#else
-    refPos16 = ((j*scaleY + addY) >> shiftYM4) - deltaY;
-#endif
-    phase    = refPos16 & 15;
-    refPos   = refPos16 >> 4;
-    coeff = m_lumaFilter[phase];
-#else
-    Int refPos12 = (Int) (j * sFactor12 );
-    Int refPos = (Int)( j * sFactor );
-    Int phase = (refPos12 + 12) % 12;
-    Int* coeff = m_lumaFilter[phase];
-#endif
-
-    piSrcY = piTempBufY + (refPos -((NTAPS_US_LUMA>>1) - 1))*strideEL;
-    piDstY = piDstBufY + j * strideEL;
-#if SCALED_REF_LAYER_OFFSETS
-    for( i = 0; i < pcTempPic->getWidth(); i++ )
-#else
-    for( i = 0; i < widthEL; i++ )
-#endif
-    {
-      *piDstY = ClipY( (sumLumaVer(piSrcY, coeff, strideEL) + iOffset) >> (nShift));
-#if SCALED_REF_LAYER_OFFSETS
-      // Only increase the x position of reference upsample picture when within the window
-      // "-2" to ensure that pointer doesn't go beyond the boundary rightEndL-1
-      if( (i >= leftStartL) && (i <= rightEndL-2) )
-      {
-        piSrcY++;
-      }
-#else
-      piSrcY++;
-#endif
-      piDstY++;
-    }
-  }
-
-#if ILP_DECODED_PICTURE
-#if SCALED_REF_LAYER_OFFSETS
-  widthBL   = pcBasePic->getWidth ();
-  heightBL  = pcBasePic->getHeight();
-
-  widthEL   = pcUsPic->getWidth () - scalEL.getWindowLeftOffset() - scalEL.getWindowRightOffset();
-  heightEL  = pcUsPic->getHeight() - scalEL.getWindowTopOffset()  - scalEL.getWindowBottomOffset();
-#else
-  widthBL   = pcBasePic->getWidth () - confBL.getWindowLeftOffset() - confBL.getWindowRightOffset();
-  heightBL  = pcBasePic->getHeight() - confBL.getWindowTopOffset() - confBL.getWindowBottomOffset();
-
-  widthEL   = pcUsPic->getWidth () - confEL.getWindowLeftOffset() - confEL.getWindowRightOffset();
-  heightEL  = pcUsPic->getHeight() - confEL.getWindowTopOffset() - confEL.getWindowBottomOffset();
-#endif
-#endif
-
-  //========== UV component upsampling ===========
-
-  widthEL  >>= 1;
-  heightEL >>= 1;
-
-  widthBL  >>= 1;
-  heightBL >>= 1;
-
-  strideBL  = pcBasePic->getCStride();
-  strideEL  = pcUsPic->getCStride();
-#if SCALED_REF_LAYER_OFFSETS
-  Int leftStartC = scalEL.getWindowLeftOffset() >> 1;
-  Int rightEndC  = (pcUsPic->getWidth() >> 1) - (scalEL.getWindowRightOffset() >> 1);
-  Int topStartC  = scalEL.getWindowTopOffset() >> 1;
-  Int bottomEndC = (pcUsPic->getHeight() >> 1) - (scalEL.getWindowBottomOffset() >> 1);
-#endif
-
-#if PHASE_DERIVATION_IN_INTEGER
-  shiftX = 16;
-  shiftY = 16;
-
-  phaseX = 0;
-  phaseY = 1;
-
-  addX       = ( ( ( widthBL * phaseX ) << ( shiftX - 2 ) ) + ( widthEL >> 1 ) ) / widthEL + ( 1 << ( shiftX - 5 ) );
-  addY       = ( ( ( heightBL * phaseY ) << ( shiftY - 2 ) ) + ( heightEL >> 1 ) ) / heightEL+ ( 1 << ( shiftY - 5 ) );
-
-  deltaX     = 4 * phaseX;
-  deltaY     = 4 * phaseY;
-
-  shiftXM4 = shiftX - 4;
-  shiftYM4 = shiftY - 4;
-
-  scaleX     = ( ( widthBL << shiftX ) + ( widthEL >> 1 ) ) / widthEL;
-  scaleY     = ( ( heightBL << shiftY ) + ( heightEL >> 1 ) ) / heightEL;
-#endif
-
-#if ILP_DECODED_PICTURE
-  widthEL   = pcUsPic->getWidth () >> 1;
-  heightEL  = pcUsPic->getHeight() >> 1;
-
-  widthBL   = pcBasePic->getWidth () >> 1;
-  heightBL  = min<Int>( pcBasePic->getHeight(), heightEL );
-#endif
-
-  //========== horizontal upsampling ===========
-  for( i = 0; i < widthEL; i++ )
-  {
-#if SCALED_REF_LAYER_OFFSETS
-    Int x = Clip3(leftStartC, rightEndC - 1, i);
-#endif
-#if PHASE_DERIVATION_IN_INTEGER
-#if SCALED_REF_LAYER_OFFSETS
-    refPos16 = (((x - leftStartC)*scaleX + addX) >> shiftXM4) - deltaX;
-#else
-    refPos16 = ((i*scaleX + addX) >> shiftXM4) - deltaX;
-#endif
-    phase    = refPos16 & 15;
-    refPos   = refPos16 >> 4;
-    coeff = m_chromaFilter[phase];
-#else
-    Int refPosM = (Int) ( i * chromaPhaseDenominator * sFactor );
-    Int refPos = (Int)( i * sFactor );
-    Int phase = (refPosM + chromaPhaseDenominator) % chromaPhaseDenominator;
-    Int* coeff = m_chromaFilter[phase];
-#endif
-
-    piSrcU = piSrcBufU + refPos -((NTAPS_US_CHROMA>>1) - 1);
-    piSrcV = piSrcBufV + refPos -((NTAPS_US_CHROMA>>1) - 1);
-    piDstU = piTempBufU + i;
-    piDstV = piTempBufV + i;
-
-    for( j = 0; j < heightBL ; j++ )
-    {
-      *piDstU = sumChromaHor(piSrcU, coeff);
-      *piDstV = sumChromaHor(piSrcV, coeff);
-
-      piSrcU += strideBL;
-      piSrcV += strideBL;
-      piDstU += strideEL;
-      piDstV += strideEL;
-    }
-  }
-
-  //========== vertical upsampling ===========
-  pcTempPic->setBorderExtension(false);
-  pcTempPic->setHeight(heightBL << 1);
-  pcTempPic->extendPicBorder   (); // extend the border.
-  pcTempPic->setHeight(heightEL << 1);
-
-#if SCALED_REF_LAYER_OFFSETS
-  for( j = 0; j < pcTempPic->getHeight() >> 1; j++ )
-#else
-    for( j = 0; j < heightEL; j++ )
-#endif
-  {
-#if SCALED_REF_LAYER_OFFSETS
-    Int y = Clip3(topStartC, bottomEndC - 1, j);
-#endif
-#if PHASE_DERIVATION_IN_INTEGER
-#if SCALED_REF_LAYER_OFFSETS
-    refPos16 = (((y - topStartC)*scaleY + addY) >> shiftYM4) - deltaY;
-#else
-    refPos16 = ((j*scaleY + addY) >> shiftYM4) - deltaY;
-#endif
-    phase    = refPos16 & 15;
-    refPos   = refPos16 >> 4; 
-    coeff = m_chromaFilter[phase];
-#else
-    Int refPosM = (Int) (j * chromaPhaseDenominator * sFactor) - 1;
-    Int refPos; 
-    if ( refPosM < 0 )
-    {
-      refPos = (Int)( j * sFactor ) - 1;
-    }
-    else
-    {
-      refPos = refPosM / chromaPhaseDenominator;
-    }
-    Int phase = (refPosM + chromaPhaseDenominator) % chromaPhaseDenominator;
-    Int* coeff = m_chromaFilter[phase];
-#endif
-
-    piSrcU = piTempBufU  + (refPos -((NTAPS_US_CHROMA>>1) - 1))*strideEL;
-    piSrcV = piTempBufV  + (refPos -((NTAPS_US_CHROMA>>1) - 1))*strideEL;
-
-    piDstU = piDstBufU + j*strideEL;
-    piDstV = piDstBufV + j*strideEL;
-
-#if SCALED_REF_LAYER_OFFSETS
-    for( i = 0; i < pcTempPic->getWidth() >> 1; i++ )
-#else
-    for( i = 0; i < widthEL; i++ )
-#endif
-    {
-      *piDstU = ClipC( (sumChromaVer(piSrcU, coeff, strideEL) + iOffset) >> (nShift));
-      *piDstV = ClipC( (sumChromaVer(piSrcV, coeff, strideEL) + iOffset) >> (nShift));
-
-#if SCALED_REF_LAYER_OFFSETS
-      // Only increase the x position of reference upsample picture when within the window
-      // "-2" to ensure that pointer doesn't go beyond the boundary rightEndC-1
-      if( (i >= leftStartC) && (i <= rightEndC-2) )
-      {
+      piSrcU = piTempBufU  + (refPos -((NTAPS_US_CHROMA>>1) - 1))*strideEL;
+      piSrcV = piTempBufV  + (refPos -((NTAPS_US_CHROMA>>1) - 1))*strideEL;
+#if SCALED_REF_LAYER_OFFSETS
+#if 1 // it should provide identical result
+      Pel* piDstU0 = piDstBufU + j*strideEL;
+      Pel* piDstV0 = piDstBufV + j*strideEL;
+      piDstU = piDstU0 + ( leftStartC > 0 ? leftStartC : 0 );
+      piDstV = piDstV0 + ( leftStartC > 0 ? leftStartC : 0 );
+
+      for( i = min<Int>(rightEndC, pcTempPic->getWidth() >> 1) - max<Int>(0, leftStartC); i > 0; i-- )
+      {
+        *piDstU = ClipC( (sumChromaVer(piSrcU, coeff, strideEL) + iOffset) >> (nShift));
+        *piDstV = ClipC( (sumChromaVer(piSrcV, coeff, strideEL) + iOffset) >> (nShift));
         piSrcU++;
         piSrcV++;
-      }
-#else
-      piSrcU++;
-      piSrcV++;
-#endif
-      piDstU++;
-      piDstV++;
-    }
-  }
-
-  pcUsPic->setBorderExtension(false);
-  pcUsPic->extendPicBorder   (); // extend the border.
-
-  //Reset the Border extension flag
-  pcUsPic->setBorderExtension(false);
-  pcTempPic->setBorderExtension(false);
-  pcBasePic->setBorderExtension(false);
-  
-#if JCTVC_L0178
-  // copy back the saved cropped region
-  if( tempBufSizeRight )
-  {
-    // put the correct width back
-    pcBasePic->setWidth(pcBasePic->getWidth() + confBL.getWindowRightOffset());
-  }
-  if( tempBufSizeBottom )
-  {
-    pcBasePic->setHeight(pcBasePic->getHeight() + confBL.getWindowBottomOffset());
-  }
-  
-  widthBL   = pcBasePic->getWidth () - confBL.getWindowLeftOffset() - confBL.getWindowRightOffset();
-  heightBL  = pcBasePic->getHeight() - confBL.getWindowTopOffset() - confBL.getWindowBottomOffset();
-  
-  strideBL  = pcBasePic->getStride();
-  
-  if( tempBufSizeRight )
-  {
-    piSrcY = tempBufRight;
-    piDstY = piSrcBufY + widthBL;
-    
-    for( i = 0; i < pcBasePic->getHeight(); i++ )
-    {
-      memcpy(piDstY, piSrcY, sizeof(Pel) * confBL.getWindowRightOffset() );
-      piSrcY += confBL.getWindowRightOffset();
-      piDstY += strideBL;
-    }
-    
-    if(confBL.getWindowRightOffset()>>1)
-    {
-      Int strideBLChroma = (strideBL>>1);
-      piSrcU = tempBufRight + confBL.getWindowRightOffset() * pcBasePic->getHeight();
-      piDstU = piSrcBufU + (widthBL>>1);
-      piSrcV = piSrcU + (confBL.getWindowRightOffset()>>1) * (pcBasePic->getHeight()>>1);
-      piDstV = piSrcBufV + (widthBL>>1);
-
-      for( i = 0; i < pcBasePic->getHeight()>>1; i++ )
-      {
-        memcpy(piDstU, piSrcU, sizeof(Pel) * (confBL.getWindowRightOffset()>>1));
-        piSrcU += (confBL.getWindowRightOffset()>>1);
-        piDstU += strideBLChroma;
-        
-        memcpy(piDstV, piSrcV, sizeof(Pel) * (confBL.getWindowRightOffset()>>1));
-        piSrcV += (confBL.getWindowRightOffset()>>1);
-        piDstV += strideBLChroma;
-      }
-    }
-  }
-  
-  if( tempBufSizeBottom )
-  {
-    piDstY = piSrcBufY + heightBL * strideBL;
-    piSrcY = tempBufBottom;
-    for( i = 0; i < confBL.getWindowBottomOffset(); i++ )
-    {
-      memcpy(piDstY, piSrcY, sizeof(Pel) * pcBasePic->getWidth());
-      piDstY += strideBL;
-      piSrcY += pcBasePic->getWidth();
-    }
-    
-    if(confBL.getWindowBottomOffset()>>1)
-    {
-      Int strideBLChroma = (strideBL>>1);
-      piSrcU = tempBufBottom + confBL.getWindowBottomOffset() * pcBasePic->getWidth();
-      piDstU = piSrcBufU + (heightBL>>1) * strideBLChroma;
-      piSrcV = piSrcU + (confBL.getWindowBottomOffset()>>1) * (pcBasePic->getWidth()>>1);
-      piDstV = piSrcBufV + (heightBL>>1) * strideBLChroma;
-            
-      for( i = 0; i < confBL.getWindowBottomOffset()>>1; i++ )
-      {
-        memcpy(piDstU, piSrcU, sizeof(Pel) * (pcBasePic->getWidth()>>1));
-        piSrcU += (pcBasePic->getWidth()>>1);
-        piDstU += strideBLChroma;
-        
-        memcpy(piDstV, piSrcV, sizeof(Pel) * (pcBasePic->getWidth()>>1));
-        piSrcV += (pcBasePic->getWidth()>>1);
-        piDstV += strideBLChroma;
-      }
-    }
-  
-  }
-
-  if( tempBufSizeRight )
-  {
-    xFree( tempBufRight );
-  }
-  if( tempBufSizeBottom )
-  {
-    xFree( tempBufBottom );
-  }
-#endif
+        piDstU++;
+        piDstV++;
+      }
+
+      for( i = rightEndC; i < pcTempPic->getWidth() >> 1; i++ )
+      {
+        *piDstU = piDstU0[rightEndC-1];
+        *piDstV = piDstV0[rightEndC-1];
+        piDstU++;
+        piDstV++;
+      }
+
+      piDstU = piDstU0;
+      piDstV = piDstV0;
+      for( i = 0; i < leftStartC; i++ )
+      {
+        *piDstU = piDstU0[leftStartC];
+        *piDstV = piDstV0[leftStartC];
+        piDstU++;
+        piDstV++;
+      }
+#else
+      piDstU = piDstBufU + j*strideEL;
+      piDstV = piDstBufV + j*strideEL;
+
+      for( i = 0; i < pcTempPic->getWidth() >> 1; i++ )
+      {
+        *piDstU = ClipC( (sumChromaVer(piSrcU, coeff, strideEL) + iOffset) >> (nShift));
+        *piDstV = ClipC( (sumChromaVer(piSrcV, coeff, strideEL) + iOffset) >> (nShift));
+
+        // Only increase the x position of reference upsample picture when within the window
+        // "-2" to ensure that pointer doesn't go beyond the boundary rightEndC-1
+        if( (i >= leftStartC) && (i <= rightEndC-2) )
+        {
+          piSrcU++;
+          piSrcV++;
+        }
+
+        piDstU++;
+        piDstV++;
+      }
+#endif
+#else
+      piDstU = piDstBufU + j*strideEL;
+      piDstV = piDstBufV + j*strideEL;
+
+      for( i = 0; i < widthEL; i++ )
+      {
+        *piDstU = ClipC( (sumChromaVer(piSrcU, coeff, strideEL) + iOffset) >> (nShift));
+        *piDstV = ClipC( (sumChromaVer(piSrcV, coeff, strideEL) + iOffset) >> (nShift));
+        piSrcU++;
+        piSrcV++;
+        piDstU++;
+        piDstV++;
+      }
+#endif
+    }
+
+    pcUsPic->setBorderExtension(false);
+    pcUsPic->extendPicBorder   (); // extend the border.
+
+    //Reset the Border extension flag
+    pcUsPic->setBorderExtension(false);
+    pcTempPic->setBorderExtension(false);
+    pcBasePic->setBorderExtension(false);
   }
 }
Index: trunk/source/Lib/TLibCommon/TComUpsampleFilter.h
===================================================================
--- trunk/source/Lib/TLibCommon/TComUpsampleFilter.h	(revision 230)
+++ trunk/source/Lib/TLibCommon/TComUpsampleFilter.h	(revision 310)
@@ -13,5 +13,4 @@
 {
 private:
-#if PHASE_DERIVATION_IN_INTEGER
   static const Int m_lumaFixedFilter[16][NTAPS_US_LUMA];     ///< Luma filter taps for both 1.5x and 2x scalability
   static const Int m_chromaFixedFilter[16][NTAPS_US_CHROMA]; ///< Chroma filter taps for 1.5x scalability
@@ -19,12 +18,4 @@
   Int m_lumaFilter[16][NTAPS_US_LUMA];
   Int m_chromaFilter[16][NTAPS_US_CHROMA];
-#else
-  static const Int m_lumaFixedFilter[12][NTAPS_US_LUMA];     ///< Luma filter taps for both 1.5x and 2x scalability
-  static const Int m_chromaFixedFilter20[8][NTAPS_US_CHROMA]; ///< Chroma filter taps for 2x scalability
-  static const Int m_chromaFixedFilter15[12][NTAPS_US_CHROMA]; ///< Chroma filter taps for 1.5x scalability
-
-  Int m_lumaFilter[12][NTAPS_US_LUMA];
-  Int m_chromaFilter[12][NTAPS_US_CHROMA];
-#endif
 
   static inline Int sumLumaHor( Pel* pel, Int* coeff )
@@ -53,7 +44,7 @@
 
 #if SCALED_REF_LAYER_OFFSETS
-  Void upsampleBasePic( TComPicYuv* pcUsPic, TComPicYuv* pcBasePic, TComPicYuv* pcTempPic, const Window window );
+  Void upsampleBasePic( UInt refLayerIdc, TComPicYuv* pcUsPic, TComPicYuv* pcBasePic, TComPicYuv* pcTempPic, const Window window );
 #else
- Void upsampleBasePic( TComPicYuv* pcUsPic, TComPicYuv* pcBasePic, TComPicYuv* pcTempPic );
+ Void upsampleBasePic( UInt refLayerIdc, TComPicYuv* pcUsPic, TComPicYuv* pcBasePic, TComPicYuv* pcTempPic );
 #endif
 };
Index: trunk/source/Lib/TLibCommon/TComWeightPrediction.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComWeightPrediction.cpp	(revision 230)
+++ trunk/source/Lib/TLibCommon/TComWeightPrediction.cpp	(revision 310)
@@ -271,4 +271,6 @@
 Void TComWeightPrediction::getWpScaling( TComDataCU* pcCU, Int iRefIdx0, Int iRefIdx1, wpScalingParam *&wp0, wpScalingParam *&wp1)
 {
+  assert(iRefIdx0 >= 0 || iRefIdx1 >= 0);
+  
   TComSlice*      pcSlice       = pcCU->getSlice();
   TComPPS*        pps           = pcCU->getSlice()->getPPS();
